|  | Home · All Classes · Modules

# QPixmapCache Class Reference
[QtGui module]

The QPixmapCache class provides an application-wide cache for pixmaps. More...

### Methods

- __init__ (self)
- __init__ (self, QPixmapCache other)

### Static Methods

- int cacheLimit ()
- clear ()
- QPixmap find (QString key)
- bool find (QString key, QPixmap)
- bool insert (QString key, QPixmap)
- remove (QString key)
- setCacheLimit (int)

## Detailed Description

The QPixmapCache class provides an application-wide cache for pixmaps.

This class is a tool for optimized drawing with QPixmap. You can use it to store temporary pixmaps that are expensive to generate without using more storage space than cacheLimit(). Use insert() to insert pixmaps, find() to find them, and clear() to empty the cache.

QPixmapCache contains no member data, only static functions to access the global pixmap cache. It creates an internal QCache object for caching the pixmaps.

The cache associates a pixmap with a string (key). If two pixmaps are inserted into the cache using equal keys, then the last pixmap will hide the first pixmap. The QHash and QCache classes do exactly the same.

The cache becomes full when the total size of all pixmaps in the cache exceeds cacheLimit(). The initial cache limit is 1024 KB (1 MB); it is changed with setCacheLimit(). A pixmap takes roughly (width * height * depth)/8 bytes of memory.

The Qt Quarterly article Optimizing with QPixmapCache explains how to use QPixmapCache to speed up applications by caching the results of painting.

See also QCache and QPixmap.

## Method Documentation

### QPixmapCache.__init__ (self)

### QPixmapCache.__init__ (self, QPixmapCache other)

### int QPixmapCache.cacheLimit ()

Returns the cache limit (in kilobytes).

The default setting is 1024 kilobytes.

See also setCacheLimit().

### QPixmapCache.clear ()

Removes all pixmaps from the cache.

### QPixmap QPixmapCache.find (QString key)

Looks for a cached pixmap associated with the key in the cache. If the pixmap is found, the function sets pm to that pixmap and returns true; otherwise it leaves pm alone and returns false.

Example:

     QPixmap pm;
     if (!QPixmapCache.find("my_big_image", pm)) {
         pm.load("bigimage.png");
         QPixmapCache.insert("my_big_image", pm);
     }
     painter->drawPixmap(0, 0, pm);

### bool QPixmapCache.find (QString key, QPixmap)

### bool QPixmapCache.insert (QString key, QPixmap)

Inserts a copy of the pixmap pm associated with the key into the cache.

All pixmaps inserted by the Qt library have a key starting with "$qt", so your own pixmap keys should never begin "$qt".

When a pixmap is inserted and the cache is about to exceed its limit, it removes pixmaps until there is enough room for the pixmap to be inserted.

The oldest pixmaps (least recently accessed in the cache) are deleted when more space is needed.

The function returns true if the object was inserted into the cache; otherwise it returns false.

See also setCacheLimit().

### QPixmapCache.remove (QString key)

Removes the pixmap associated with key from the cache.

### QPixmapCache.setCacheLimit (int)

Sets the cache limit to n kilobytes.

The default setting is 1024 kilobytes.

See also cacheLimit().